import es
import playerlib
import time
import math
import sqlite3
import langlib
import re
import popuplib

info = es.AddonInfo()
info.name = 'FGBank'
info.version = '1.0.4'
info.url = 'http://addons.eventscripts.com/addons/view/fgbank'
info.basename = 'fgbank'
info.author = 'Freigeist'

################ DO NOT EDIT OVER THIS LINE! ###############

##########
# Config #
##########
fgbank_inactivity = es.ServerVar("fgbank_inactivity", 14, "How long a play can be inactiv before removed from Database (in Days) 0 = deactivated")
fgbank_interestrate = es.ServerVar("fgbank_interestrate", 0.05, "This is the interest rate which will be distributed every round. (in Percent)")
fgbank_maxinterests = es.ServerVar("fgbank_maxinterests", 0, "How many interest a player can earn at begin of a round. 0 = unlimited")

################ DO NOT EDIT BELOW THIS LINE! ################

###########
# Globals #
###########
lang = langlib.Strings(es.getAddonPath('fgbank') + '/fgbank_lang.ini')
conn = sqlite3.connect(es.getAddonPath('fgbank') + '/fgbank.sqlitedb')
conn.text_factory = str 
cur = conn.cursor()

#############
# Functions #
#############

def load():
	es.set('fgbank_version', info.version)
	es.makepublic('fgbank_version')
	
	if not es.exists('saycommand', '/deposit'):
		es.regsaycmd('/deposit', 'fgbank/deposit')
	if not es.exists('saycommand', '/autodeposit'):
		es.regsaycmd('/autodeposit', 'fgbank/autodeposit')
	if not es.exists('saycommand', '/withdraw'):
		es.regsaycmd('/withdraw', 'fgbank/withdraw')
	if not es.exists('saycommand', '/autowithdraw'):
		es.regsaycmd('/autowithdraw', 'fgbank/autowithdraw')
	if not es.exists('saycommand', '/balance'):
		es.regsaycmd('/balance', 'fgbank/balance')
	if not es.exists('saycommand', '/bank'):
		es.regsaycmd('/bank', 'fgbank/bank')
	if not es.exists('saycommand', '!deposit'):
		es.regsaycmd('!deposit', 'fgbank/deposit')
	if not es.exists('saycommand', '!autodeposit'):
		es.regsaycmd('!autodeposit', 'fgbank/autodeposit')
	if not es.exists('saycommand', '!withdraw'):
		es.regsaycmd('!withdraw', 'fgbank/withdraw')
	if not es.exists('saycommand', '!autowithdraw'):
		es.regsaycmd('!autowithdraw', 'fgbank/autowithdraw')
	if not es.exists('saycommand', '!balance'):
		es.regsaycmd('!balance', 'fgbank/balance')
	if not es.exists('saycommand', '!bank'):
		es.regsaycmd('!bank', 'fgbank/bank')
	#es.regclientcmd('command', 'script/function', 'Comment')

	cur.execute('CREATE TABLE IF NOT EXISTS bank (steamid VARCHAR PRIMARY KEY NOT NULL UNIQUE, name VARCHAR NOT NULL, money INTEGER NOT NULL DEFAULT 0, withdraw INTEGER NOT NULL DEFAULT 0, deposit INTEGER NOT NULL DEFAULT 0, hidden INTEGER NOT NULL DEFAULT 0, protected INTEGER NOT NULL DEFAULT 0, timestamp INTEGER NOT NULL DEFAULT 0);')
	
	#remove inactive players from database
	timestamp = getts()
	if fgbank_inactivity > 0:
		querytimestamp = timestamp-(fgbank_inactivity*86400)
		vars = (querytimestamp,)
		cur.execute("DELETE FROM bank WHERE timestamp < ? AND protected = 0;", vars)
		cur.execute("VACUUM;")
		conn.commit()
	
	PlayerList = playerlib.getPlayerList('#human')
	for ply in PlayerList:
		timestamp = getts()
		vars = (ply.steamid,)
		cur.execute("SELECT steamid FROM bank WHERE steamid = ?;", vars)
		result = cur.fetchone()
		if result is None:
			vars = (ply.steamid,ply.name,timestamp)
			cur.execute("INSERT INTO bank (steamid,name,timestamp) VALUES (?,?,?);", vars)
			conn.commit()
			log("Added new player \"" + ply.name + "\" (" + ply.steamid + ") to database")
		else:
			vars = (ply.name,timestamp,ply.steamid)
			cur.execute("UPDATE bank SET name = ?, timestamp = ? WHERE steamid = ?;", vars)
			conn.commit()
	
def unload():
	es.unregsaycmd('/deposit')
	es.unregsaycmd('/withdraw')
	es.unregsaycmd('/balance')
	es.unregsaycmd('/autowithdraw')
	es.unregsaycmd('/autodeposit')
	es.unregsaycmd('/bank')
	es.unregsaycmd('!deposit')
	es.unregsaycmd('!withdraw')
	es.unregsaycmd('!balance')
	es.unregsaycmd('!autowithdraw')
	es.unregsaycmd('!autodeposit')
	es.unregsaycmd('!bank')
	conn.commit()
	conn.close()

def log(msg):
	es.log("[FGBank] %s" % msg)

def es_player_validated(event_var):
	timestamp = getts()
	vars = (event_var['networkid'],)
	cur.execute("SELECT steamid FROM bank WHERE steamid = ?;", vars)
	result = cur.fetchone()
	if result is None:
		vars = (event_var['networkid'],event_var["name"],timestamp)
		cur.execute("INSERT INTO bank (steamid,name,timestamp) VALUES (?,?,?);", vars)
		conn.commit()
		log("Added new player \"" + event_var["name"] + "\" (" + event_var['networkid'] + ") to database")
	else:
		vars = (event_var["name"],timestamp,event_var['networkid'])
		cur.execute("UPDATE bank SET name = ?, timestamp = ? WHERE steamid = ?;", vars)
		conn.commit()

def round_start(event_var):
	if fgbank_inactivity > 0:
		timestamp = getts()
		querytimestamp = timestamp-(fgbank_inactivity*86400)
		vars = (querytimestamp,)
		cur.execute("DELETE FROM bank WHERE timestamp < ? AND protected = 0;", vars)
		cur.execute("VACUUM;")
		conn.commit()
	numply = getanzply()
	interestrate_m = fgbank_interestrate / 100.0
	if numply >= 2:
		PlayerList = playerlib.getPlayerList('#ct')
		for ply in PlayerList:
			interest = float(getbalance(ply.steamid))
			interest *= interestrate_m
			interest = str(int(math.ceil(interest)))
			dodeposit(interest, ply.userid, ply.steamid, 1)
		PlayerList = playerlib.getPlayerList('#t')
		for ply in PlayerList:
			interest = float(getbalance(ply.steamid))
			interest *= interestrate_m
			interest = str(int(math.ceil(interest)))
			dodeposit(interest, ply.userid, ply.steamid, 1)

def player_spawn(event_var):
	userid = event_var['userid']
	steamid = playerlib.uniqueid(userid)
	teamid = int(event_var['es_userteam'])
	numply = int(getanzply())
	if numply >= 2:
		if (teamid == 2) or (teamid == 3):
			playercash = playerlib.getPlayer(userid).get("cash")
			withdraw = getsql("withdraw", steamid)
			deposit = getsql("deposit", steamid)
			if (withdraw > playercash) and (withdraw != 0):
				withdraw -= playercash
				withdraw = str(withdraw)
				dowithdraw(withdraw, userid, steamid)
			elif (deposit < playercash) and (deposit != 0):
				deposit = playercash - deposit
				deposit = str(deposit)
				dodeposit(deposit, userid, steamid)
			tokens = {}
			es.tell(userid, "#multi", lang("fgbank is running", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("to prevent cheating all", tokens, playerlib.getPlayer(userid).get("lang")))
			
def getanzply():
	anzply = 0
	PlayerList = playerlib.getPlayerList('#ct')
	for ply in PlayerList:
		anzply = anzply + 1
		#es.msg(ply.steamid)
		#es.msg(anzply)
	PlayerList = playerlib.getPlayerList('#t')
	for ply in PlayerList:
		anzply = anzply + 1
		#es.msg(ply.steamid)
		#es.msg(anzply)
	return anzply

def getts():
	ts = int(math.ceil(time.time()))
	#log(ts)
	return ts

def deposit():
	numply = int(getanzply())
	args = es.getargc()
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if numply >= 2:
		if args == 1:
			show_depositmenu()
		elif args == 2:
			deposittemp = es.getargv(1)
			dodeposit(deposittemp, userid, steamid)
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("too many parameters", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))

def withdraw():
	numply = int(getanzply())
	args = es.getargc()
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if numply >= 2:
		if args == 1:
			show_withdrawmenu()
		elif args == 2:
			withdrawtemp = es.getargv(1)
			dowithdraw(withdrawtemp, userid, steamid)
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("too many parameters", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))

def balance():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	balance = getbalance(steamid)
	tokens = {}
	tokens['balance'] = balance
	es.tell(userid, "#multi", lang("your balance is", tokens, playerlib.getPlayer(userid).get("lang")))

def autowithdraw():
	args = es.getargc()
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if args == 1:
		show_autowithdrawmenu()
	elif args == 2:
		awithdrawtemp = es.getargv(1)
		if re.match("[0-9-]*$", awithdrawtemp):
			awithdrawtemp = int(awithdrawtemp)
			if awithdrawtemp < 0:
				awithdrawtemp = 0
			if awithdrawtemp > 16000:
				awithdrawtemp = 16000
				
			setsql("withdraw", awithdrawtemp, steamid)
			tokens = {}
			tokens['number'] = awithdrawtemp
			es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("no valid number", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("too many parameters", tokens, playerlib.getPlayer(userid).get("lang")))

def autodeposit():
	args = es.getargc()
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if args == 1:
		show_autodepositmenu()
	elif args == 2:
		adeposittemp = es.getargv(1)
		if re.match("[0-9-]*$", adeposittemp):
			adeposittemp = int(adeposittemp)
			if adeposittemp < 0:
				adeposittemp = 0
			if adeposittemp > 16000:
				adeposittemp = 16000
				
			setsql("deposit", adeposittemp, steamid)
			tokens = {}
			tokens['number'] = adeposittemp
			es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("no valid number", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("too many parameters", tokens, playerlib.getPlayer(userid).get("lang")))

def dodeposit(deposittemp, userid, steamid, interest=0):
	numply = int(getanzply())
	if numply >= 2:
		if re.match("[0-9-]*$", deposittemp):
			deposittemp = int(deposittemp)
			if interest == 0:
				if deposittemp < 0:
					deposittemp = 0
				if deposittemp > 16000:
					deposittemp = 16000
			elif (fgbank_maxinterests > 0) and (deposittemp > fgbank_maxinterests):
				deposittemp = fgbank_maxinterests
			
			balance = getbalance(steamid)
			test = 2000000000 - balance
			if test == 0:
				deposittemp = 0
				if interest == 0:
					tokens = {}
					es.tell(userid, "#multi", lang("reached maximum", tokens, playerlib.getPlayer(userid).get("lang")))
				else:
					tokens = {}
					es.tell(userid, "#multi", lang("interests reached maximum", tokens, playerlib.getPlayer(userid).get("lang")))
			elif test <= deposittemp:
				deposittemp = test
			
			if interest == 0:
				dplayer = playerlib.getPlayer(userid)
				dplayercash = dplayer.get("cash")
				
				if dplayercash < deposittemp:
					deposittemp = dplayercash
				
				dplayercash = dplayercash - deposittemp
				dplayer.set("cash", dplayercash)
			
			timestamp = getts()
			vars = (int(deposittemp), timestamp, steamid)
			cur.execute("UPDATE bank SET money = (money + ?), timestamp = ? WHERE steamid = ?;", vars)
			conn.commit()
			
			if interest == 0:
				tokens = {}
				tokens['number'] = deposittemp
				es.tell(userid, "#multi", lang("you have deposited", tokens, playerlib.getPlayer(userid).get("lang")))
			else:
				if deposittemp != 0:
					tokens = {}
					tokens['number'] = deposittemp
					es.tell(userid, "#multi", lang("earned interests", tokens, playerlib.getPlayer(userid).get("lang")))
			deposittemp = None
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("no valid number", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))

def dowithdraw(withdrawtemp, userid, steamid):
	numply = int(getanzply())
	if numply >= 2:
		if re.match("[0-9-]*$", withdrawtemp):
			withdrawtemp = int(withdrawtemp)
			if withdrawtemp < 0:
				withdrawtemp = 0
			if withdrawtemp > 16000:
				withdrawtemp = 16000
			
			wplayer = playerlib.getPlayer(userid)
			wplayercash = wplayer.get("cash")
			
			bankmoney = getbalance(steamid)
			
			if bankmoney <= withdrawtemp:
				withdrawtemp = bankmoney
			
			test = withdrawtemp + wplayercash
			if test > 16000:
				withdrawtemp = test - 16000 - withdrawtemp
				if withdrawtemp < 0:
					test = -1
					withdrawtemp *= test
			
			timestamp = getts()
			vars = (withdrawtemp, timestamp, steamid)
			cur.execute("UPDATE bank SET money = (money - ?), timestamp = ? WHERE steamid = ?;", vars)
			conn.commit()
			
			wplayercash = wplayercash + withdrawtemp
			wplayer.set("cash", wplayercash)
			
			tokens = {}
			tokens['number'] = withdrawtemp
			es.tell(userid, "#multi", lang("you have withdrawn", tokens, playerlib.getPlayer(userid).get("lang")))
			withdrawtemp = None
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("no valid number", tokens, playerlib.getPlayer(userid).get("lang")))
	else:
		tokens = {}
		es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))

def getbalance(steamid):
	vars = (steamid,)
	cur.execute("SELECT money FROM bank WHERE steamid=?;", vars)
	result = cur.fetchone()
	return int(result[0])

def getsql(opt, steamid):
	vars = (steamid,)
	if opt == "withdraw":
		return getsqlquery("SELECT withdraw FROM bank WHERE steamid=?;", vars)
	elif opt == "deposit":
		return getsqlquery("SELECT deposit FROM bank WHERE steamid=?;", vars)
	elif opt == "hidden":
		return getsqlquery("SELECT hidden FROM bank WHERE steamid=?;", vars)
	elif opt == "protected":
		return getsqlquery("SELECT protected FROM bank WHERE steamid=?;", vars)
	else:
		return "error-50" # An insider

def getsqlquery(sql, vars):
	cur.execute(sql, vars)
	result = cur.fetchone()
	return int(result[0])

def setsql(opt, value, steamid):
	vars = (value, steamid)
	if opt == "withdraw":
		cur.execute("UPDATE bank SET withdraw = ? WHERE steamid=?;", vars)
		conn.commit()
	elif opt == "deposit":
		cur.execute("UPDATE bank SET deposit = ? WHERE steamid=?;", vars)
		conn.commit()
	elif opt == "hidden":
		cur.execute("UPDATE bank SET hidden = ? WHERE steamid=?;", vars)
		conn.commit()
	elif opt == "protected":
		cur.execute("UPDATE bank SET protected = ? WHERE steamid=?;", vars)
		conn.commit()

def gettop10():
	cur.execute("SELECT name,money FROM bank WHERE hidden = 0 ORDER BY money DESC LIMIT 10;")
	i = 0
	for row in cur:
		name,money = row
		if i == 0:
			vars = (name, money)
		else:
			vars = vars + (name, money)
		i += 1
	
	while i < 10:
		vars = vars + ("-", "0")
		i += 1
	
	return vars

#####################
#       Menus       #	
#####################

def bank():
	show_mainmenu()

def from_mainmenu():
	userid = es.getcmduserid()
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		numply = int(getanzply())
		if numply >= 2:
			show_depositmenu()
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))
			show_mainmenu()
	elif popupchoice == 2:
		numply = int(getanzply())
		if numply >= 2:
			show_withdrawmenu()
		else:
			tokens = {}
			es.tell(userid, "#multi", lang("to prevent cheating one", tokens, playerlib.getPlayer(userid).get("lang")))
			show_mainmenu()
	elif popupchoice == 3:
		show_top10menu()
	elif popupchoice == 4:
		show_autodepositmenu()
	elif popupchoice == 5:
		show_autowithdrawmenu()
	elif popupchoice == 6:
		show_optionhidemenu()
	else:
		if popupchoice != 10:
			show_mainmenu()

def from_depositmenu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		dodeposit("2000", userid, steamid)
	elif popupchoice == 2:
		dodeposit("4000", userid, steamid)
	elif popupchoice == 3:
		dodeposit("6000", userid, steamid)
	elif popupchoice == 4:
		dodeposit("8000", userid, steamid)
	elif popupchoice == 5:
		dodeposit("10000", userid, steamid)
	elif popupchoice == 6:
		dodeposit("12000", userid, steamid)
	elif popupchoice == 7:
		dodeposit("14000", userid, steamid)
	elif popupchoice == 8:
		dodeposit("16000", userid, steamid)
	elif popupchoice == 10:
		show_mainmenu()
	else:
		show_depositmenu()

def from_autodepositmenu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		setsql("deposit", 2000, steamid)
		tokens = {}
		tokens['number'] = "2000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 2:
		setsql("deposit", 4000, steamid)
		tokens = {}
		tokens['number'] = "4000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 3:
		setsql("deposit", 6000, steamid)
		tokens = {}
		tokens['number'] = "6000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 4:
		setsql("deposit", 8000, steamid)
		tokens = {}
		tokens['number'] = "8000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 5:
		setsql("deposit", 10000, steamid)
		tokens = {}
		tokens['number'] = "10000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 6:
		setsql("deposit", 12000, steamid)
		tokens = {}
		tokens['number'] = "12000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 7:
		setsql("deposit", 14000, steamid)
		tokens = {}
		tokens['number'] = "14000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 8:
		setsql("deposit", 16000, steamid)
		tokens = {}
		tokens['number'] = "16000"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 9:
		setsql("deposit", 0, steamid)
		tokens = {}
		tokens['number'] = "0"
		es.tell(userid, "#multi", lang("set automatic deposit", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 10:
		show_mainmenu()
	else:
		show_autodepositmenu()

def from_withdrawmenu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		dowithdraw("2000", userid, steamid)
	elif popupchoice == 2:
		dowithdraw("4000", userid, steamid)
	elif popupchoice == 3:
		dowithdraw("6000", userid, steamid)
	elif popupchoice == 4:
		dowithdraw("8000", userid, steamid)
	elif popupchoice == 5:
		dowithdraw("10000", userid, steamid)
	elif popupchoice == 6:
		dowithdraw("12000", userid, steamid)
	elif popupchoice == 7:
		dowithdraw("14000", userid, steamid)
	elif popupchoice == 8:
		dowithdraw("16000", userid, steamid)
	elif popupchoice == 10:
		show_mainmenu()
	else:
		show_withdrawmenu()

def from_autowithdrawmenu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		setsql("withdraw", 2000, steamid)
		tokens = {}
		tokens['number'] = "2000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 2:
		setsql("withdraw", 4000, steamid)
		tokens = {}
		tokens['number'] = "4000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 3:
		setsql("withdraw", 6000, steamid)
		tokens = {}
		tokens['number'] = "6000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 4:
		setsql("withdraw", 8000, steamid)
		tokens = {}
		tokens['number'] = "8000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 5:
		setsql("withdraw", 10000, steamid)
		tokens = {}
		tokens['number'] = "10000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 6:
		setsql("withdraw", 12000, steamid)
		tokens = {}
		tokens['number'] = "12000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 7:
		setsql("withdraw", 14000, steamid)
		tokens = {}
		tokens['number'] = "14000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 8:
		setsql("withdraw", 16000, steamid)
		tokens = {}
		tokens['number'] = "16000"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 9:
		setsql("withdraw", 0, steamid)
		tokens = {}
		tokens['number'] = "0"
		es.tell(userid, "#multi", lang("set automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 10:
		show_mainmenu()
	else:
		show_autowithdrawmenu()

def from_top10menu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 10:
		show_mainmenu()
	else:
		show_top10menu()

def from_optionhidemenu():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	popupchoice = es.getInt('_popup_choice')
	if popupchoice == 1:
		setsql("hidden", 0, steamid)
		tokens = {}
		es.tell(userid, "#multi", lang("now visible", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 2:
		setsql("hidden", 1, steamid)
		tokens = {}
		es.tell(userid, "#multi", lang("now hidden", tokens, playerlib.getPlayer(userid).get("lang")))
	elif popupchoice == 10:
		show_mainmenu()
	else:
		show_optionhidemenu()

def show_mainmenu():
	userid = es.getcmduserid()
	version = info.version
	balance = getbalance(es.getplayersteamid(userid))
	numply = int(getanzply())
	####################
	tokens = {}
	str_mainmenu = lang("main menu", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentbalance = lang("current balance", tokens, playerlib.getPlayer(userid).get("lang"))
	str_deposit = lang("deposit", tokens, playerlib.getPlayer(userid).get("lang"))
	str_withdraw = lang("withdraw", tokens, playerlib.getPlayer(userid).get("lang"))
	str_top10 = lang("top10", tokens, playerlib.getPlayer(userid).get("lang"))
	str_adeposit = lang("configure automatic deposit", tokens, playerlib.getPlayer(userid).get("lang"))
	str_awithdraw = lang("configure automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang"))
	str_top10settings = lang("top10 settings", tokens, playerlib.getPlayer(userid).get("lang"))
	str_close = lang("close", tokens, playerlib.getPlayer(userid).get("lang"))
	#####################
	vars = (version,str_mainmenu,str_currentbalance,balance,str_deposit,str_withdraw,str_top10,str_adeposit,str_awithdraw,str_top10settings,str_close)
	if numply >= 2:
		popuplib.quicksend(0, userid, "FGBank %s\n\n%s\n--------\n%s: %s$\n--------\n->1. %s\n->2. %s\n->3. %s\n->4. %s\n->5. %s\n->6. %s\n--------\n->0. %s" % vars, 'fgbank/from_mainmenu')
	else:
		popuplib.quicksend(0, userid, "FGBank %s\n\n%s\n--------\n%s: %s$\n--------\n1. %s\n2. %s\n->3. %s\n->4. %s\n->5. %s\n->6. %s\n--------\n->0. %s" % vars, 'fgbank/from_mainmenu')

def show_depositmenu():
	userid = es.getcmduserid()
	version = info.version
	balance = getbalance(es.getplayersteamid(userid))
	######################
	tokens = {}
	str_deposit = lang("deposit", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentbalance = lang("current balance", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	vars = (version,str_deposit,str_currentbalance,balance,str_back)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n%s: %s$\n--------\n->1. 2000$\n->2. 4000$\n->3. 6000$\n->4. 8000$\n->5. 10000$\n->6. 12000$\n->7. 14000$\n->8. 16000$\n--------\n->0. %s' % vars, 'fgbank/from_depositmenu')

def show_withdrawmenu():
	userid = es.getcmduserid()
	version = info.version
	balance = getbalance(es.getplayersteamid(userid))
	######################
	tokens = {}
	str_withdraw = lang("withdraw", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentbalance = lang("current balance", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	vars = (version,str_withdraw,str_currentbalance,balance,str_back)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n%s: %s$\n--------\n->1. 2000$\n->2. 4000$\n->3. 6000$\n->4. 8000$\n->5. 10000$\n->6. 12000$\n->7. 14000$\n->8. 16000$\n--------\n->0. %s' % vars, 'fgbank/from_withdrawmenu')

def show_autodepositmenu():
	userid = es.getcmduserid()
	version = info.version
	option = getsql("deposit", es.getplayersteamid(userid))
	######################
	tokens = {}
	str_adeposit = lang("configure automatic deposit", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentsetting = lang("current setting", tokens, playerlib.getPlayer(userid).get("lang"))
	str_turnoff = lang("turn off", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	vars = (version,str_adeposit,str_currentsetting,option,str_turnoff,str_back)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n%s: %s$\n--------\n->1. 2000$\n->2. 4000$\n->3. 6000$\n->4. 8000$\n->5. 10000$\n->6. 12000$\n->7. 14000$\n->8. 16000$\n->9. %s\n--------\n->0. %s' % vars, 'fgbank/from_autodepositmenu')

def show_autowithdrawmenu():
	userid = es.getcmduserid()
	version = info.version
	option = getsql("withdraw", es.getplayersteamid(userid))
	######################
	tokens = {}
	str_awithdraw = lang("configure automatic withdraw", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentsetting = lang("current setting", tokens, playerlib.getPlayer(userid).get("lang"))
	str_turnoff = lang("turn off", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	vars = (version,str_awithdraw,str_currentsetting,option,str_turnoff,str_back)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n%s: %s$\n--------\n->1. 2000$\n->2. 4000$\n->3. 6000$\n->4. 8000$\n->5. 10000$\n->6. 12000$\n->7. 14000$\n->8. 16000$\n->9. %s\n--------\n->0. %s' % vars, 'fgbank/from_autowithdrawmenu')

def show_top10menu():
	userid = es.getcmduserid()
	version = info.version
	top10 = gettop10()
	######################
	tokens = {}
	str_top10 = lang("top10", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	vars = (version,str_top10) + top10 + (str_back,)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n1. %s %s$\n2. %s %s$\n3. %s %s$\n4. %s %s$\n5. %s %s$\n6. %s %s$\n7. %s %s$\n8. %s %s$\n9. %s %s$\n10. %s %s$\n--------\n->0. %s' % vars, 'fgbank/from_top10menu')

def show_optionhidemenu():
	userid = es.getcmduserid()
	version = info.version
	option = getsql("hidden", es.getplayersteamid(userid))
	######################
	tokens = {}
	str_top10settings = lang("top10 settings", tokens, playerlib.getPlayer(userid).get("lang"))
	str_currentsetting = lang("current setting", tokens, playerlib.getPlayer(userid).get("lang"))
	str_hidden = lang("hidden", tokens, playerlib.getPlayer(userid).get("lang"))
	str_nothidden = lang("not hidden", tokens, playerlib.getPlayer(userid).get("lang"))
	str_hideme = lang("hide me", tokens, playerlib.getPlayer(userid).get("lang"))
	str_donthideme = lang("dont hide me", tokens, playerlib.getPlayer(userid).get("lang"))
	str_back = lang("back", tokens, playerlib.getPlayer(userid).get("lang"))
	######################
	if option == 0:
		option = str_nothidden
	else:
		option = str_hidden
	vars = (version,str_top10settings,str_currentsetting,option,str_donthideme,str_hideme,str_back)
	popuplib.quicksend(0, userid, 'FGBank %s\n%s\n--------\n%s: %s$\n--------\n->1. %s\n->2. %s\n--------\n->0. %s' % vars, 'fgbank/from_optionhidemenu')
	